package org.bdware.bdledger.api.grpc.pb;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.30.2)",
    comments = "Source: bdware/bdledger/api/query.proto")
public final class QueryGrpc {

  private QueryGrpc() {}

  public static final String SERVICE_NAME = "bdware.bdledger.api.Query";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse> getGetBlockByHashMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetBlockByHash",
      requestType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest.class,
      responseType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse> getGetBlockByHashMethod() {
    io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse> getGetBlockByHashMethod;
    if ((getGetBlockByHashMethod = QueryGrpc.getGetBlockByHashMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetBlockByHashMethod = QueryGrpc.getGetBlockByHashMethod) == null) {
          QueryGrpc.getGetBlockByHashMethod = getGetBlockByHashMethod =
              io.grpc.MethodDescriptor.<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetBlockByHash"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetBlockByHash"))
              .build();
        }
      }
    }
    return getGetBlockByHashMethod;
  }

  private static volatile io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse> getGetBlocksMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetBlocks",
      requestType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest.class,
      responseType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse> getGetBlocksMethod() {
    io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse> getGetBlocksMethod;
    if ((getGetBlocksMethod = QueryGrpc.getGetBlocksMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetBlocksMethod = QueryGrpc.getGetBlocksMethod) == null) {
          QueryGrpc.getGetBlocksMethod = getGetBlocksMethod =
              io.grpc.MethodDescriptor.<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetBlocks"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetBlocks"))
              .build();
        }
      }
    }
    return getGetBlocksMethod;
  }

  private static volatile io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse> getCountBlocksMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "CountBlocks",
      requestType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest.class,
      responseType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse> getCountBlocksMethod() {
    io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse> getCountBlocksMethod;
    if ((getCountBlocksMethod = QueryGrpc.getCountBlocksMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getCountBlocksMethod = QueryGrpc.getCountBlocksMethod) == null) {
          QueryGrpc.getCountBlocksMethod = getCountBlocksMethod =
              io.grpc.MethodDescriptor.<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "CountBlocks"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("CountBlocks"))
              .build();
        }
      }
    }
    return getCountBlocksMethod;
  }

  private static volatile io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse> getGetTransactionByHashMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactionByHash",
      requestType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest.class,
      responseType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse> getGetTransactionByHashMethod() {
    io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse> getGetTransactionByHashMethod;
    if ((getGetTransactionByHashMethod = QueryGrpc.getGetTransactionByHashMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetTransactionByHashMethod = QueryGrpc.getGetTransactionByHashMethod) == null) {
          QueryGrpc.getGetTransactionByHashMethod = getGetTransactionByHashMethod =
              io.grpc.MethodDescriptor.<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetTransactionByHash"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetTransactionByHash"))
              .build();
        }
      }
    }
    return getGetTransactionByHashMethod;
  }

  private static volatile io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse> getGetTransactionByBlockHashAndIndexMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactionByBlockHashAndIndex",
      requestType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest.class,
      responseType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse> getGetTransactionByBlockHashAndIndexMethod() {
    io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse> getGetTransactionByBlockHashAndIndexMethod;
    if ((getGetTransactionByBlockHashAndIndexMethod = QueryGrpc.getGetTransactionByBlockHashAndIndexMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetTransactionByBlockHashAndIndexMethod = QueryGrpc.getGetTransactionByBlockHashAndIndexMethod) == null) {
          QueryGrpc.getGetTransactionByBlockHashAndIndexMethod = getGetTransactionByBlockHashAndIndexMethod =
              io.grpc.MethodDescriptor.<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetTransactionByBlockHashAndIndex"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetTransactionByBlockHashAndIndex"))
              .build();
        }
      }
    }
    return getGetTransactionByBlockHashAndIndexMethod;
  }

  private static volatile io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse> getGetTransactionsMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "GetTransactions",
      requestType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest.class,
      responseType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse> getGetTransactionsMethod() {
    io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse> getGetTransactionsMethod;
    if ((getGetTransactionsMethod = QueryGrpc.getGetTransactionsMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getGetTransactionsMethod = QueryGrpc.getGetTransactionsMethod) == null) {
          QueryGrpc.getGetTransactionsMethod = getGetTransactionsMethod =
              io.grpc.MethodDescriptor.<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "GetTransactions"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("GetTransactions"))
              .build();
        }
      }
    }
    return getGetTransactionsMethod;
  }

  private static volatile io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse> getCountTransactionsMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "CountTransactions",
      requestType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest.class,
      responseType = org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest,
      org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse> getCountTransactionsMethod() {
    io.grpc.MethodDescriptor<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse> getCountTransactionsMethod;
    if ((getCountTransactionsMethod = QueryGrpc.getCountTransactionsMethod) == null) {
      synchronized (QueryGrpc.class) {
        if ((getCountTransactionsMethod = QueryGrpc.getCountTransactionsMethod) == null) {
          QueryGrpc.getCountTransactionsMethod = getCountTransactionsMethod =
              io.grpc.MethodDescriptor.<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest, org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "CountTransactions"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse.getDefaultInstance()))
              .setSchemaDescriptor(new QueryMethodDescriptorSupplier("CountTransactions"))
              .build();
        }
      }
    }
    return getCountTransactionsMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static QueryStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<QueryStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<QueryStub>() {
        @java.lang.Override
        public QueryStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new QueryStub(channel, callOptions);
        }
      };
    return QueryStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static QueryBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<QueryBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<QueryBlockingStub>() {
        @java.lang.Override
        public QueryBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new QueryBlockingStub(channel, callOptions);
        }
      };
    return QueryBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static QueryFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<QueryFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<QueryFutureStub>() {
        @java.lang.Override
        public QueryFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new QueryFutureStub(channel, callOptions);
        }
      };
    return QueryFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class QueryImplBase implements io.grpc.BindableService {

    /**
     * <pre>
     **
     * Get a block identified by its hash
     * 查询哈希所指定的区块
     * </pre>
     */
    public void getBlockByHash(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetBlockByHashMethod(), responseObserver);
    }

    /**
     * <pre>
     **
     * Get blocks in a timestamp range
     * 查询时间范围内的区块
     * start_timestamp is required
     * </pre>
     */
    public void getBlocks(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetBlocksMethod(), responseObserver);
    }

    /**
     * <pre>
     **
     * Count all blocks in a ledger, or blocks in a timestamp range
     * 查询帐本中的所有区块数量，或时间范围内的区块数量
     * </pre>
     */
    public void countBlocks(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getCountBlocksMethod(), responseObserver);
    }

    /**
     * <pre>
     **
     * Get a transaction identified by its hash
     * 查询哈希所指定的事务
     * </pre>
     */
    public void getTransactionByHash(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionByHashMethod(), responseObserver);
    }

    /**
     * <pre>
     **
     * Get a transaction identified by hash of the block it belongs to and its index inside the block
     * 查询所在区块的哈希与其在区块中的index所指定的事务
     * </pre>
     */
    public void getTransactionByBlockHashAndIndex(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionByBlockHashAndIndexMethod(), responseObserver);
    }

    /**
     * <pre>
     **
     * Get transactions in a timestamp range
     * 查询时间范围内的事务
     * </pre>
     */
    public void getTransactions(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetTransactionsMethod(), responseObserver);
    }

    /**
     * <pre>
     **
     * Count all transactions in a ledger, or transactions in a timestamp range
     * 查询帐本中的所有事务数量，或时间范围内的事务数量
     * start_timestamp is required
     * </pre>
     */
    public void countTransactions(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getCountTransactionsMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getGetBlockByHashMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest,
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse>(
                  this, METHODID_GET_BLOCK_BY_HASH)))
          .addMethod(
            getGetBlocksMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest,
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse>(
                  this, METHODID_GET_BLOCKS)))
          .addMethod(
            getCountBlocksMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest,
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse>(
                  this, METHODID_COUNT_BLOCKS)))
          .addMethod(
            getGetTransactionByHashMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest,
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse>(
                  this, METHODID_GET_TRANSACTION_BY_HASH)))
          .addMethod(
            getGetTransactionByBlockHashAndIndexMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest,
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse>(
                  this, METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX)))
          .addMethod(
            getGetTransactionsMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest,
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse>(
                  this, METHODID_GET_TRANSACTIONS)))
          .addMethod(
            getCountTransactionsMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest,
                org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse>(
                  this, METHODID_COUNT_TRANSACTIONS)))
          .build();
    }
  }

  /**
   */
  public static final class QueryStub extends io.grpc.stub.AbstractAsyncStub<QueryStub> {
    private QueryStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected QueryStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new QueryStub(channel, callOptions);
    }

    /**
     * <pre>
     **
     * Get a block identified by its hash
     * 查询哈希所指定的区块
     * </pre>
     */
    public void getBlockByHash(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetBlockByHashMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     **
     * Get blocks in a timestamp range
     * 查询时间范围内的区块
     * start_timestamp is required
     * </pre>
     */
    public void getBlocks(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetBlocksMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     **
     * Count all blocks in a ledger, or blocks in a timestamp range
     * 查询帐本中的所有区块数量，或时间范围内的区块数量
     * </pre>
     */
    public void countBlocks(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCountBlocksMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     **
     * Get a transaction identified by its hash
     * 查询哈希所指定的事务
     * </pre>
     */
    public void getTransactionByHash(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionByHashMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     **
     * Get a transaction identified by hash of the block it belongs to and its index inside the block
     * 查询所在区块的哈希与其在区块中的index所指定的事务
     * </pre>
     */
    public void getTransactionByBlockHashAndIndex(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionByBlockHashAndIndexMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     **
     * Get transactions in a timestamp range
     * 查询时间范围内的事务
     * </pre>
     */
    public void getTransactions(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetTransactionsMethod(), getCallOptions()), request, responseObserver);
    }

    /**
     * <pre>
     **
     * Count all transactions in a ledger, or transactions in a timestamp range
     * 查询帐本中的所有事务数量，或时间范围内的事务数量
     * start_timestamp is required
     * </pre>
     */
    public void countTransactions(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest request,
        io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getCountTransactionsMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class QueryBlockingStub extends io.grpc.stub.AbstractBlockingStub<QueryBlockingStub> {
    private QueryBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected QueryBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new QueryBlockingStub(channel, callOptions);
    }

    /**
     * <pre>
     **
     * Get a block identified by its hash
     * 查询哈希所指定的区块
     * </pre>
     */
    public org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse getBlockByHash(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetBlockByHashMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     **
     * Get blocks in a timestamp range
     * 查询时间范围内的区块
     * start_timestamp is required
     * </pre>
     */
    public org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse getBlocks(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetBlocksMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     **
     * Count all blocks in a ledger, or blocks in a timestamp range
     * 查询帐本中的所有区块数量，或时间范围内的区块数量
     * </pre>
     */
    public org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse countBlocks(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest request) {
      return blockingUnaryCall(
          getChannel(), getCountBlocksMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     **
     * Get a transaction identified by its hash
     * 查询哈希所指定的事务
     * </pre>
     */
    public org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse getTransactionByHash(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionByHashMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     **
     * Get a transaction identified by hash of the block it belongs to and its index inside the block
     * 查询所在区块的哈希与其在区块中的index所指定的事务
     * </pre>
     */
    public org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse getTransactionByBlockHashAndIndex(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionByBlockHashAndIndexMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     **
     * Get transactions in a timestamp range
     * 查询时间范围内的事务
     * </pre>
     */
    public org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse getTransactions(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetTransactionsMethod(), getCallOptions(), request);
    }

    /**
     * <pre>
     **
     * Count all transactions in a ledger, or transactions in a timestamp range
     * 查询帐本中的所有事务数量，或时间范围内的事务数量
     * start_timestamp is required
     * </pre>
     */
    public org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse countTransactions(org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest request) {
      return blockingUnaryCall(
          getChannel(), getCountTransactionsMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class QueryFutureStub extends io.grpc.stub.AbstractFutureStub<QueryFutureStub> {
    private QueryFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected QueryFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new QueryFutureStub(channel, callOptions);
    }

    /**
     * <pre>
     **
     * Get a block identified by its hash
     * 查询哈希所指定的区块
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse> getBlockByHash(
        org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetBlockByHashMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     **
     * Get blocks in a timestamp range
     * 查询时间范围内的区块
     * start_timestamp is required
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse> getBlocks(
        org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetBlocksMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     **
     * Count all blocks in a ledger, or blocks in a timestamp range
     * 查询帐本中的所有区块数量，或时间范围内的区块数量
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse> countBlocks(
        org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCountBlocksMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     **
     * Get a transaction identified by its hash
     * 查询哈希所指定的事务
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse> getTransactionByHash(
        org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionByHashMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     **
     * Get a transaction identified by hash of the block it belongs to and its index inside the block
     * 查询所在区块的哈希与其在区块中的index所指定的事务
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse> getTransactionByBlockHashAndIndex(
        org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionByBlockHashAndIndexMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     **
     * Get transactions in a timestamp range
     * 查询时间范围内的事务
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse> getTransactions(
        org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetTransactionsMethod(), getCallOptions()), request);
    }

    /**
     * <pre>
     **
     * Count all transactions in a ledger, or transactions in a timestamp range
     * 查询帐本中的所有事务数量，或时间范围内的事务数量
     * start_timestamp is required
     * </pre>
     */
    public com.google.common.util.concurrent.ListenableFuture<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse> countTransactions(
        org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getCountTransactionsMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_GET_BLOCK_BY_HASH = 0;
  private static final int METHODID_GET_BLOCKS = 1;
  private static final int METHODID_COUNT_BLOCKS = 2;
  private static final int METHODID_GET_TRANSACTION_BY_HASH = 3;
  private static final int METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX = 4;
  private static final int METHODID_GET_TRANSACTIONS = 5;
  private static final int METHODID_COUNT_TRANSACTIONS = 6;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final QueryImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(QueryImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GET_BLOCK_BY_HASH:
          serviceImpl.getBlockByHash((org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashRequest) request,
              (io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlockByHashResponse>) responseObserver);
          break;
        case METHODID_GET_BLOCKS:
          serviceImpl.getBlocks((org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest) request,
              (io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetBlocksResponse>) responseObserver);
          break;
        case METHODID_COUNT_BLOCKS:
          serviceImpl.countBlocks((org.bdware.bdledger.api.grpc.pb.QueryOuterClass.BlocksRequest) request,
              (io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountBlocksResponse>) responseObserver);
          break;
        case METHODID_GET_TRANSACTION_BY_HASH:
          serviceImpl.getTransactionByHash((org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashRequest) request,
              (io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByHashResponse>) responseObserver);
          break;
        case METHODID_GET_TRANSACTION_BY_BLOCK_HASH_AND_INDEX:
          serviceImpl.getTransactionByBlockHashAndIndex((org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexRequest) request,
              (io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionByBlockHashAndIndexResponse>) responseObserver);
          break;
        case METHODID_GET_TRANSACTIONS:
          serviceImpl.getTransactions((org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest) request,
              (io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.GetTransactionsResponse>) responseObserver);
          break;
        case METHODID_COUNT_TRANSACTIONS:
          serviceImpl.countTransactions((org.bdware.bdledger.api.grpc.pb.QueryOuterClass.TransactionsRequest) request,
              (io.grpc.stub.StreamObserver<org.bdware.bdledger.api.grpc.pb.QueryOuterClass.CountTransactionsResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class QueryBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    QueryBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return org.bdware.bdledger.api.grpc.pb.QueryOuterClass.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("Query");
    }
  }

  private static final class QueryFileDescriptorSupplier
      extends QueryBaseDescriptorSupplier {
    QueryFileDescriptorSupplier() {}
  }

  private static final class QueryMethodDescriptorSupplier
      extends QueryBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    QueryMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (QueryGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new QueryFileDescriptorSupplier())
              .addMethod(getGetBlockByHashMethod())
              .addMethod(getGetBlocksMethod())
              .addMethod(getCountBlocksMethod())
              .addMethod(getGetTransactionByHashMethod())
              .addMethod(getGetTransactionByBlockHashAndIndexMethod())
              .addMethod(getGetTransactionsMethod())
              .addMethod(getCountTransactionsMethod())
              .build();
        }
      }
    }
    return result;
  }
}
